diff --git a/src/backend/catalog/pg_db_role_setting.c b/src/backend/catalog/pg_db_role_setting.c
index 57d5f5f391b..ee58c21922b 100644
--- a/src/backend/catalog/pg_db_role_setting.c
+++ b/src/backend/catalog/pg_db_role_setting.c
@@ -74,21 +74,18 @@ AlterSetting(Oid databaseid, Oid roleid, VariableSetStmt *setstmt)
 
 			if (new)
 			{
-				Datum		repl_val[Natts_pg_db_role_setting];
-				bool		repl_null[Natts_pg_db_role_setting];
-				bool		repl_repl[Natts_pg_db_role_setting];
+				Datum		values[Natts_pg_db_role_setting] = {0};
+				bool		nulls[Natts_pg_db_role_setting] = {false};
 				HeapTuple	newtuple;
+				Bitmapset  *updated = NULL;
 
-				memset(repl_repl, false, sizeof(repl_repl));
+				HeapTupleUpdateValue(pg_db_role_setting, setconfig, PointerGetDatum(new), values, nulls, updated);
 
-				repl_val[Anum_pg_db_role_setting_setconfig - 1] =
-					PointerGetDatum(new);
-				repl_repl[Anum_pg_db_role_setting_setconfig - 1] = true;
-				repl_null[Anum_pg_db_role_setting_setconfig - 1] = false;
+				newtuple = heap_update_tuple(tuple, RelationGetDescr(rel),
+											 values, nulls, updated);
+				CatalogTupleUpdate(rel, &tuple->t_self, newtuple, updated, NULL);
 
-				newtuple = heap_modify_tuple(tuple, RelationGetDescr(rel),
-											 repl_val, repl_null, repl_repl);
-				CatalogTupleUpdate(rel, &tuple->t_self, newtuple);
+				bms_free(updated);
 			}
 			else
 				CatalogTupleDelete(rel, &tuple->t_self);
@@ -96,18 +93,14 @@ AlterSetting(Oid databaseid, Oid roleid, VariableSetStmt *setstmt)
 	}
 	else if (HeapTupleIsValid(tuple))
 	{
-		Datum		repl_val[Natts_pg_db_role_setting];
-		bool		repl_null[Natts_pg_db_role_setting];
-		bool		repl_repl[Natts_pg_db_role_setting];
+		Datum		values[Natts_pg_db_role_setting] = {0};
+		bool		nulls[Natts_pg_db_role_setting] = {false};
+		Bitmapset  *updated = NULL;
 		HeapTuple	newtuple;
 		Datum		datum;
 		bool		isnull;
 		ArrayType  *a;
 
-		memset(repl_repl, false, sizeof(repl_repl));
-		repl_repl[Anum_pg_db_role_setting_setconfig - 1] = true;
-		repl_null[Anum_pg_db_role_setting_setconfig - 1] = false;
-
 		/* Extract old value of setconfig */
 		datum = heap_getattr(tuple, Anum_pg_db_role_setting_setconfig,
 							 RelationGetDescr(rel), &isnull);
@@ -121,12 +114,12 @@ AlterSetting(Oid databaseid, Oid roleid, VariableSetStmt *setstmt)
 
 		if (a)
 		{
-			repl_val[Anum_pg_db_role_setting_setconfig - 1] =
-				PointerGetDatum(a);
+			HeapTupleUpdateValue(pg_db_role_setting, setconfig, PointerGetDatum(a), values, nulls, updated);
 
-			newtuple = heap_modify_tuple(tuple, RelationGetDescr(rel),
-										 repl_val, repl_null, repl_repl);
-			CatalogTupleUpdate(rel, &tuple->t_self, newtuple);
+			newtuple = heap_update_tuple(tuple, RelationGetDescr(rel),
+										 values, nulls, updated);
+			CatalogTupleUpdate(rel, &tuple->t_self, newtuple, updated, NULL);
+			bms_free(updated);
 		}
 		else
 			CatalogTupleDelete(rel, &tuple->t_self);
@@ -135,21 +128,18 @@ AlterSetting(Oid databaseid, Oid roleid, VariableSetStmt *setstmt)
 	{
 		/* non-null valuestr means it's not RESET, so insert a new tuple */
 		HeapTuple	newtuple;
-		Datum		values[Natts_pg_db_role_setting];
-		bool		nulls[Natts_pg_db_role_setting];
+		Datum		values[Natts_pg_db_role_setting] = {0};
+		bool		nulls[Natts_pg_db_role_setting] = {false};
 		ArrayType  *a;
 
-		memset(nulls, false, sizeof(nulls));
-
 		a = GUCArrayAdd(NULL, setstmt->name, valuestr);
 
-		values[Anum_pg_db_role_setting_setdatabase - 1] =
-			ObjectIdGetDatum(databaseid);
-		values[Anum_pg_db_role_setting_setrole - 1] = ObjectIdGetDatum(roleid);
-		values[Anum_pg_db_role_setting_setconfig - 1] = PointerGetDatum(a);
+		HeapTupleSetValue(pg_db_role_setting, setdatabase, ObjectIdGetDatum(databaseid), values);
+		HeapTupleSetValue(pg_db_role_setting, setrole, ObjectIdGetDatum(roleid), values);
+		HeapTupleSetValue(pg_db_role_setting, setconfig, PointerGetDatum(a), values);
 		newtuple = heap_form_tuple(RelationGetDescr(rel), values, nulls);
 
-		CatalogTupleInsert(rel, newtuple);
+		CatalogTupleInsert(rel, newtuple, NULL);
 	}
 	else
 	{
diff --git a/src/backend/catalog/pg_depend.c b/src/backend/catalog/pg_depend.c
index 55309d16f15..433e574f4dc 100644
--- a/src/backend/catalog/pg_depend.c
+++ b/src/backend/catalog/pg_depend.c
@@ -61,7 +61,7 @@ recordMultipleDependencies(const ObjectAddress *depender,
 {
 	Relation	dependDesc;
 	CatalogIndexState indstate;
-	TupleTableSlot **slot;
+	TupleTableSlot **slots;
 	int			i,
 				max_slots,
 				slot_init_count,
@@ -88,7 +88,7 @@ recordMultipleDependencies(const ObjectAddress *depender,
 	 */
 	max_slots = Min(nreferenced,
 					MAX_CATALOG_MULTI_INSERT_BYTES / sizeof(FormData_pg_depend));
-	slot = palloc_array(TupleTableSlot *, max_slots);
+	slots = palloc_array(TupleTableSlot *, max_slots);
 
 	/* Don't open indexes unless we need to make an update */
 	indstate = NULL;
@@ -99,6 +99,9 @@ recordMultipleDependencies(const ObjectAddress *depender,
 	slot_init_count = 0;
 	for (i = 0; i < nreferenced; i++, referenced++)
 	{
+		TupleTableSlot *slot;
+		Datum	   *values;
+
 		/*
 		 * If the referenced object is pinned by the system, there's no real
 		 * need to record dependencies on it.  This saves lots of space in
@@ -109,29 +112,32 @@ recordMultipleDependencies(const ObjectAddress *depender,
 
 		if (slot_init_count < max_slots)
 		{
-			slot[slot_stored_count] = MakeSingleTupleTableSlot(RelationGetDescr(dependDesc),
-															   &TTSOpsHeapTuple);
+			slots[slot_stored_count] = MakeSingleTupleTableSlot(RelationGetDescr(dependDesc),
+																&TTSOpsHeapTuple);
 			slot_init_count++;
 		}
 
-		ExecClearTuple(slot[slot_stored_count]);
+		ExecClearTuple(slots[slot_stored_count]);
+
+		slot = slots[slot_stored_count];
+		values = slot->tts_values;
 
 		/*
 		 * Record the dependency.  Note we don't bother to check for duplicate
 		 * dependencies; there's no harm in them.
 		 */
-		slot[slot_stored_count]->tts_values[Anum_pg_depend_refclassid - 1] = ObjectIdGetDatum(referenced->classId);
-		slot[slot_stored_count]->tts_values[Anum_pg_depend_refobjid - 1] = ObjectIdGetDatum(referenced->objectId);
-		slot[slot_stored_count]->tts_values[Anum_pg_depend_refobjsubid - 1] = Int32GetDatum(referenced->objectSubId);
-		slot[slot_stored_count]->tts_values[Anum_pg_depend_deptype - 1] = CharGetDatum((char) behavior);
-		slot[slot_stored_count]->tts_values[Anum_pg_depend_classid - 1] = ObjectIdGetDatum(depender->classId);
-		slot[slot_stored_count]->tts_values[Anum_pg_depend_objid - 1] = ObjectIdGetDatum(depender->objectId);
-		slot[slot_stored_count]->tts_values[Anum_pg_depend_objsubid - 1] = Int32GetDatum(depender->objectSubId);
-
-		memset(slot[slot_stored_count]->tts_isnull, false,
-			   slot[slot_stored_count]->tts_tupleDescriptor->natts * sizeof(bool));
-
-		ExecStoreVirtualTuple(slot[slot_stored_count]);
+		HeapTupleSetValue(pg_depend, refclassid, ObjectIdGetDatum(referenced->classId), values);
+		HeapTupleSetValue(pg_depend, refobjid, ObjectIdGetDatum(referenced->objectId), values);
+		HeapTupleSetValue(pg_depend, refobjsubid, Int32GetDatum(referenced->objectSubId), values);
+		HeapTupleSetValue(pg_depend, deptype, CharGetDatum((char) behavior), values);
+		HeapTupleSetValue(pg_depend, classid, ObjectIdGetDatum(depender->classId), values);
+		HeapTupleSetValue(pg_depend, objid, ObjectIdGetDatum(depender->objectId), values);
+		HeapTupleSetValue(pg_depend, objsubid, Int32GetDatum(depender->objectSubId), values);
+
+		memset(slot->tts_isnull, false,
+			   slot->tts_tupleDescriptor->natts * sizeof(bool));
+
+		ExecStoreVirtualTuple(slot);
 		slot_stored_count++;
 
 		/* If slots are full, insert a batch of tuples */
@@ -141,8 +147,7 @@ recordMultipleDependencies(const ObjectAddress *depender,
 			if (indstate == NULL)
 				indstate = CatalogOpenIndexes(dependDesc);
 
-			CatalogTuplesMultiInsertWithInfo(dependDesc, slot, slot_stored_count,
-											 indstate);
+			CatalogTuplesMultiInsert(dependDesc, slots, slot_stored_count, indstate);
 			slot_stored_count = 0;
 		}
 	}
@@ -154,8 +159,7 @@ recordMultipleDependencies(const ObjectAddress *depender,
 		if (indstate == NULL)
 			indstate = CatalogOpenIndexes(dependDesc);
 
-		CatalogTuplesMultiInsertWithInfo(dependDesc, slot, slot_stored_count,
-										 indstate);
+		CatalogTuplesMultiInsert(dependDesc, slots, slot_stored_count, indstate);
 	}
 
 	if (indstate != NULL)
@@ -165,8 +169,8 @@ recordMultipleDependencies(const ObjectAddress *depender,
 
 	/* Drop only the number of slots used */
 	for (i = 0; i < slot_init_count; i++)
-		ExecDropSingleTupleTableSlot(slot[i]);
-	pfree(slot);
+		ExecDropSingleTupleTableSlot(slots[i]);
+	pfree(slots);
 }
 
 /*
@@ -531,14 +535,16 @@ changeDependencyFor(Oid classId, Oid objectId,
 				CatalogTupleDelete(depRel, &tup->t_self);
 			else
 			{
+				Bitmapset  *updated = NULL;
+
 				/* make a modifiable copy */
 				tup = heap_copytuple(tup);
 				depform = (Form_pg_depend) GETSTRUCT(tup);
 
-				depform->refobjid = newRefObjectId;
-
-				CatalogTupleUpdate(depRel, &tup->t_self, tup);
+				HeapTupleUpdateField(pg_depend, refobjid, newRefObjectId, depform, updated);
+				CatalogTupleUpdate(depRel, &tup->t_self, tup, updated, NULL);
 
+				bms_free(updated);
 				heap_freetuple(tup);
 			}
 
@@ -588,15 +594,16 @@ changeDependenciesOf(Oid classId, Oid oldObjectId,
 	while (HeapTupleIsValid((tup = systable_getnext(scan))))
 	{
 		Form_pg_depend depform;
+		Bitmapset  *updated = NULL;
 
 		/* make a modifiable copy */
 		tup = heap_copytuple(tup);
 		depform = (Form_pg_depend) GETSTRUCT(tup);
 
-		depform->objid = newObjectId;
-
-		CatalogTupleUpdate(depRel, &tup->t_self, tup);
+		HeapTupleUpdateField(pg_depend, objid, newObjectId, depform, updated);
+		CatalogTupleUpdate(depRel, &tup->t_self, tup, updated, NULL);
 
+		bms_free(updated);
 		heap_freetuple(tup);
 
 		count++;
@@ -675,15 +682,16 @@ changeDependenciesOn(Oid refClassId, Oid oldRefObjectId,
 		else
 		{
 			Form_pg_depend depform;
+			Bitmapset  *updated = NULL;
 
 			/* make a modifiable copy */
 			tup = heap_copytuple(tup);
 			depform = (Form_pg_depend) GETSTRUCT(tup);
 
-			depform->refobjid = newRefObjectId;
-
-			CatalogTupleUpdate(depRel, &tup->t_self, tup);
+			HeapTupleUpdateField(pg_depend, refobjid, newRefObjectId, depform, updated);
+			CatalogTupleUpdate(depRel, &tup->t_self, tup, updated, NULL);
 
+			bms_free(updated);
 			heap_freetuple(tup);
 		}
 
diff --git a/src/backend/catalog/pg_enum.c b/src/backend/catalog/pg_enum.c
index 33a461484d4..33818f9d242 100644
--- a/src/backend/catalog/pg_enum.c
+++ b/src/backend/catalog/pg_enum.c
@@ -194,12 +194,12 @@ EnumValuesCreate(Oid enumTypeOid, List *vals)
 		memset(slot[slotCount]->tts_isnull, false,
 			   slot[slotCount]->tts_tupleDescriptor->natts * sizeof(bool));
 
-		slot[slotCount]->tts_values[Anum_pg_enum_oid - 1] = ObjectIdGetDatum(oids[elemno]);
-		slot[slotCount]->tts_values[Anum_pg_enum_enumtypid - 1] = ObjectIdGetDatum(enumTypeOid);
-		slot[slotCount]->tts_values[Anum_pg_enum_enumsortorder - 1] = Float4GetDatum(elemno + 1);
+		HeapTupleSetValue(pg_enum, oid, ObjectIdGetDatum(oids[elemno]), slot[slotCount]->tts_values);
+		HeapTupleSetValue(pg_enum, enumtypid, ObjectIdGetDatum(enumTypeOid), slot[slotCount]->tts_values);
+		HeapTupleSetValue(pg_enum, enumsortorder, Float4GetDatum(elemno + 1), slot[slotCount]->tts_values);
 
 		namestrcpy(enumlabel, lab);
-		slot[slotCount]->tts_values[Anum_pg_enum_enumlabel - 1] = NameGetDatum(enumlabel);
+		HeapTupleSetValue(pg_enum, enumlabel, NameGetDatum(enumlabel), slot[slotCount]->tts_values);
 
 		ExecStoreVirtualTuple(slot[slotCount]);
 		slotCount++;
@@ -207,8 +207,7 @@ EnumValuesCreate(Oid enumTypeOid, List *vals)
 		/* if slots are full, insert a batch of tuples */
 		if (slotCount == nslots)
 		{
-			CatalogTuplesMultiInsertWithInfo(pg_enum, slot, slotCount,
-											 indstate);
+			CatalogTuplesMultiInsert(pg_enum, slot, slotCount, indstate);
 			slotCount = 0;
 		}
 
@@ -217,10 +216,9 @@ EnumValuesCreate(Oid enumTypeOid, List *vals)
 
 	/* Insert any tuples left in the buffer */
 	if (slotCount > 0)
-		CatalogTuplesMultiInsertWithInfo(pg_enum, slot, slotCount,
-										 indstate);
+		CatalogTuplesMultiInsert(pg_enum, slot, slotCount, indstate);
 
-	/* clean up */
+	/* Clean up */
 	pfree(oids);
 	for (int i = 0; i < nslots; i++)
 		ExecDropSingleTupleTableSlot(slot[i]);
@@ -310,8 +308,8 @@ AddEnumLabel(Oid enumTypeOid,
 {
 	Relation	pg_enum;
 	Oid			newOid;
-	Datum		values[Natts_pg_enum];
-	bool		nulls[Natts_pg_enum];
+	Datum		values[Natts_pg_enum] = {0};
+	bool		nulls[Natts_pg_enum] = {false};
 	NameData	enumlabel;
 	HeapTuple	enum_tup;
 	float4		newelemorder;
@@ -577,13 +575,13 @@ restart:
 
 	/* Create the new pg_enum entry */
 	memset(nulls, false, sizeof(nulls));
-	values[Anum_pg_enum_oid - 1] = ObjectIdGetDatum(newOid);
-	values[Anum_pg_enum_enumtypid - 1] = ObjectIdGetDatum(enumTypeOid);
-	values[Anum_pg_enum_enumsortorder - 1] = Float4GetDatum(newelemorder);
+	HeapTupleSetValue(pg_enum, oid, ObjectIdGetDatum(newOid), values);
+	HeapTupleSetValue(pg_enum, enumtypid, ObjectIdGetDatum(enumTypeOid), values);
+	HeapTupleSetValue(pg_enum, enumsortorder, Float4GetDatum(newelemorder), values);
 	namestrcpy(&enumlabel, newVal);
-	values[Anum_pg_enum_enumlabel - 1] = NameGetDatum(&enumlabel);
+	HeapTupleSetValue(pg_enum, enumlabel, NameGetDatum(&enumlabel), values);
 	enum_tup = heap_form_tuple(RelationGetDescr(pg_enum), values, nulls);
-	CatalogTupleInsert(pg_enum, enum_tup);
+	CatalogTupleInsert(pg_enum, enum_tup, NULL);
 	heap_freetuple(enum_tup);
 
 	table_close(pg_enum, RowExclusiveLock);
@@ -629,6 +627,7 @@ RenameEnumLabel(Oid enumTypeOid,
 	HeapTuple	old_tup;
 	bool		found_new;
 	int			i;
+	Bitmapset  *updated = NULL;
 
 	/* check length of new label is ok */
 	if (strlen(newVal) > (NAMEDATALEN - 1))
@@ -689,9 +688,12 @@ RenameEnumLabel(Oid enumTypeOid,
 
 	/* Update the pg_enum entry */
 	namestrcpy(&en->enumlabel, newVal);
-	CatalogTupleUpdate(pg_enum, &enum_tup->t_self, enum_tup);
-	heap_freetuple(enum_tup);
+	HeapTupleMarkColumnUpdated(pg_enum, enumlabel, updated);
+
+	CatalogTupleUpdate(pg_enum, &enum_tup->t_self, enum_tup, updated, NULL);
 
+	bms_free(updated);
+	heap_freetuple(enum_tup);
 	table_close(pg_enum, RowExclusiveLock);
 }
 
@@ -792,9 +794,12 @@ RenumberEnumType(Relation pg_enum, HeapTuple *existing, int nelems)
 		newsortorder = i + 1;
 		if (en->enumsortorder != newsortorder)
 		{
-			en->enumsortorder = newsortorder;
+			Bitmapset  *updated = NULL;
+
+			HeapTupleUpdateField(pg_enum, enumsortorder, newsortorder, en, updated);
 
-			CatalogTupleUpdate(pg_enum, &newtup->t_self, newtup);
+			CatalogTupleUpdate(pg_enum, &newtup->t_self, newtup, updated, NULL);
+			bms_free(updated);
 		}
 
 		heap_freetuple(newtup);
diff --git a/src/backend/catalog/pg_inherits.c b/src/backend/catalog/pg_inherits.c
index cef80633157..710cbcfee51 100644
--- a/src/backend/catalog/pg_inherits.c
+++ b/src/backend/catalog/pg_inherits.c
@@ -507,8 +507,8 @@ typeInheritsFrom(Oid subclassTypeId, Oid superclassTypeId)
 void
 StoreSingleInheritance(Oid relationId, Oid parentOid, int32 seqNumber)
 {
-	Datum		values[Natts_pg_inherits];
-	bool		nulls[Natts_pg_inherits];
+	Datum		values[Natts_pg_inherits] = {0};
+	bool		nulls[Natts_pg_inherits] = {false};
 	HeapTuple	tuple;
 	Relation	inhRelation;
 
@@ -517,16 +517,16 @@ StoreSingleInheritance(Oid relationId, Oid parentOid, int32 seqNumber)
 	/*
 	 * Make the pg_inherits entry
 	 */
-	values[Anum_pg_inherits_inhrelid - 1] = ObjectIdGetDatum(relationId);
-	values[Anum_pg_inherits_inhparent - 1] = ObjectIdGetDatum(parentOid);
-	values[Anum_pg_inherits_inhseqno - 1] = Int32GetDatum(seqNumber);
-	values[Anum_pg_inherits_inhdetachpending - 1] = BoolGetDatum(false);
+	HeapTupleSetValue(pg_inherits, inhrelid, ObjectIdGetDatum(relationId), values);
+	HeapTupleSetValue(pg_inherits, inhparent, ObjectIdGetDatum(parentOid), values);
+	HeapTupleSetValue(pg_inherits, inhseqno, Int32GetDatum(seqNumber), values);
+	HeapTupleSetValue(pg_inherits, inhdetachpending, BoolGetDatum(false), values);
 
 	memset(nulls, 0, sizeof(nulls));
 
 	tuple = heap_form_tuple(RelationGetDescr(inhRelation), values, nulls);
 
-	CatalogTupleInsert(inhRelation, tuple);
+	CatalogTupleInsert(inhRelation, tuple, NULL);
 
 	heap_freetuple(tuple);
 
diff --git a/src/backend/catalog/pg_largeobject.c b/src/backend/catalog/pg_largeobject.c
index 0e1dd22d908..fb954d5ad24 100644
--- a/src/backend/catalog/pg_largeobject.c
+++ b/src/backend/catalog/pg_largeobject.c
@@ -40,8 +40,8 @@ LargeObjectCreate(Oid loid)
 	Relation	pg_lo_meta;
 	HeapTuple	ntup;
 	Oid			loid_new;
-	Datum		values[Natts_pg_largeobject_metadata];
-	bool		nulls[Natts_pg_largeobject_metadata];
+	Datum		values[Natts_pg_largeobject_metadata] = {0};
+	bool		nulls[Natts_pg_largeobject_metadata] = {false};
 	Oid			ownerId;
 	Acl		   *lomacl;
 
@@ -51,9 +51,6 @@ LargeObjectCreate(Oid loid)
 	/*
 	 * Insert metadata of the largeobject
 	 */
-	memset(values, 0, sizeof(values));
-	memset(nulls, false, sizeof(nulls));
-
 	if (OidIsValid(loid))
 		loid_new = loid;
 	else
@@ -63,20 +60,17 @@ LargeObjectCreate(Oid loid)
 	ownerId = GetUserId();
 	lomacl = get_user_default_acl(OBJECT_LARGEOBJECT, ownerId, InvalidOid);
 
-	values[Anum_pg_largeobject_metadata_oid - 1] = ObjectIdGetDatum(loid_new);
-	values[Anum_pg_largeobject_metadata_lomowner - 1]
-		= ObjectIdGetDatum(ownerId);
+	HeapTupleSetValue(pg_largeobject_metadata, oid, ObjectIdGetDatum(loid_new), values);
+	HeapTupleSetValue(pg_largeobject_metadata, lomowner, ObjectIdGetDatum(ownerId), values);
 
 	if (lomacl != NULL)
-		values[Anum_pg_largeobject_metadata_lomacl - 1]
-			= PointerGetDatum(lomacl);
+		HeapTupleSetValue(pg_largeobject_metadata, lomacl, PointerGetDatum(lomacl), values);
 	else
-		nulls[Anum_pg_largeobject_metadata_lomacl - 1] = true;
+		HeapTupleSetValueNull(pg_largeobject_metadata, lomacl, values, nulls);
 
-	ntup = heap_form_tuple(RelationGetDescr(pg_lo_meta),
-						   values, nulls);
+	ntup = heap_form_tuple(RelationGetDescr(pg_lo_meta), values, nulls);
 
-	CatalogTupleInsert(pg_lo_meta, ntup);
+	CatalogTupleInsert(pg_lo_meta, ntup, NULL);
 
 	heap_freetuple(ntup);
 
diff --git a/src/backend/catalog/pg_namespace.c b/src/backend/catalog/pg_namespace.c
index f35ef5a344e..9aca3cbe637 100644
--- a/src/backend/catalog/pg_namespace.c
+++ b/src/backend/catalog/pg_namespace.c
@@ -45,12 +45,11 @@ NamespaceCreate(const char *nspName, Oid ownerId, bool isTemp)
 	Relation	nspdesc;
 	HeapTuple	tup;
 	Oid			nspoid;
-	bool		nulls[Natts_pg_namespace];
-	Datum		values[Natts_pg_namespace];
+	bool		nulls[Natts_pg_namespace] = {false};
+	Datum		values[Natts_pg_namespace] = {0};
 	NameData	nname;
 	TupleDesc	tupDesc;
 	ObjectAddress myself;
-	int			i;
 	Acl		   *nspacl;
 
 	/* sanity checks */
@@ -72,28 +71,21 @@ NamespaceCreate(const char *nspName, Oid ownerId, bool isTemp)
 	nspdesc = table_open(NamespaceRelationId, RowExclusiveLock);
 	tupDesc = nspdesc->rd_att;
 
-	/* initialize nulls and values */
-	for (i = 0; i < Natts_pg_namespace; i++)
-	{
-		nulls[i] = false;
-		values[i] = (Datum) 0;
-	}
-
 	nspoid = GetNewOidWithIndex(nspdesc, NamespaceOidIndexId,
 								Anum_pg_namespace_oid);
-	values[Anum_pg_namespace_oid - 1] = ObjectIdGetDatum(nspoid);
+	HeapTupleSetValue(pg_namespace, oid, ObjectIdGetDatum(nspoid), values);
 	namestrcpy(&nname, nspName);
-	values[Anum_pg_namespace_nspname - 1] = NameGetDatum(&nname);
-	values[Anum_pg_namespace_nspowner - 1] = ObjectIdGetDatum(ownerId);
+	HeapTupleSetValue(pg_namespace, nspname, NameGetDatum(&nname), values);
+	HeapTupleSetValue(pg_namespace, nspowner, ObjectIdGetDatum(ownerId), values);
 	if (nspacl != NULL)
-		values[Anum_pg_namespace_nspacl - 1] = PointerGetDatum(nspacl);
+		HeapTupleSetValue(pg_namespace, nspacl, PointerGetDatum(nspacl), values);
 	else
-		nulls[Anum_pg_namespace_nspacl - 1] = true;
+		HeapTupleSetValueNull(pg_namespace, nspacl, values, nulls);
 
 
 	tup = heap_form_tuple(tupDesc, values, nulls);
 
-	CatalogTupleInsert(nspdesc, tup);
+	CatalogTupleInsert(nspdesc, tup, NULL);
 	Assert(OidIsValid(nspoid));
 
 	table_close(nspdesc, RowExclusiveLock);
diff --git a/src/backend/catalog/pg_operator.c b/src/backend/catalog/pg_operator.c
index 6b90c774c18..bec79133715 100644
--- a/src/backend/catalog/pg_operator.c
+++ b/src/backend/catalog/pg_operator.c
@@ -17,6 +17,7 @@
  */
 #include "postgres.h"
 
+#include "access/htup.h"
 #include "access/htup_details.h"
 #include "access/table.h"
 #include "access/xact.h"
@@ -199,10 +200,11 @@ OperatorShellMake(const char *operatorName,
 	Oid			operatorObjectId;
 	int			i;
 	HeapTuple	tup;
-	Datum		values[Natts_pg_operator];
-	bool		nulls[Natts_pg_operator];
+	Datum		values[Natts_pg_operator] = {0};
+	bool		nulls[Natts_pg_operator] = {false};
 	NameData	oname;
 	TupleDesc	tupDesc;
+	Bitmapset  *updated = NULL;
 
 	/*
 	 * validate operator name
@@ -234,22 +236,23 @@ OperatorShellMake(const char *operatorName,
 	 */
 	operatorObjectId = GetNewOidWithIndex(pg_operator_desc, OperatorOidIndexId,
 										  Anum_pg_operator_oid);
-	values[Anum_pg_operator_oid - 1] = ObjectIdGetDatum(operatorObjectId);
+
+	HeapTupleUpdateValue(pg_operator, oid, ObjectIdGetDatum(operatorObjectId), values, nulls, updated);
 	namestrcpy(&oname, operatorName);
-	values[Anum_pg_operator_oprname - 1] = NameGetDatum(&oname);
-	values[Anum_pg_operator_oprnamespace - 1] = ObjectIdGetDatum(operatorNamespace);
-	values[Anum_pg_operator_oprowner - 1] = ObjectIdGetDatum(GetUserId());
-	values[Anum_pg_operator_oprkind - 1] = CharGetDatum(leftTypeId ? 'b' : 'l');
-	values[Anum_pg_operator_oprcanmerge - 1] = BoolGetDatum(false);
-	values[Anum_pg_operator_oprcanhash - 1] = BoolGetDatum(false);
-	values[Anum_pg_operator_oprleft - 1] = ObjectIdGetDatum(leftTypeId);
-	values[Anum_pg_operator_oprright - 1] = ObjectIdGetDatum(rightTypeId);
-	values[Anum_pg_operator_oprresult - 1] = ObjectIdGetDatum(InvalidOid);
-	values[Anum_pg_operator_oprcom - 1] = ObjectIdGetDatum(InvalidOid);
-	values[Anum_pg_operator_oprnegate - 1] = ObjectIdGetDatum(InvalidOid);
-	values[Anum_pg_operator_oprcode - 1] = ObjectIdGetDatum(InvalidOid);
-	values[Anum_pg_operator_oprrest - 1] = ObjectIdGetDatum(InvalidOid);
-	values[Anum_pg_operator_oprjoin - 1] = ObjectIdGetDatum(InvalidOid);
+	HeapTupleUpdateValue(pg_operator, oprname, NameGetDatum(&oname), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprnamespace, ObjectIdGetDatum(operatorNamespace), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprowner, ObjectIdGetDatum(GetUserId()), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprkind, CharGetDatum(leftTypeId ? 'b' : 'l'), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprcanmerge, BoolGetDatum(false), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprcanhash, BoolGetDatum(false), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprleft, ObjectIdGetDatum(leftTypeId), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprright, ObjectIdGetDatum(rightTypeId), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprresult, ObjectIdGetDatum(InvalidOid), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprcom, ObjectIdGetDatum(InvalidOid), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprnegate, ObjectIdGetDatum(InvalidOid), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprcode, ObjectIdGetDatum(InvalidOid), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprrest, ObjectIdGetDatum(InvalidOid), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprjoin, ObjectIdGetDatum(InvalidOid), values, nulls, updated);
 
 	/*
 	 * create a new operator tuple
@@ -259,7 +262,7 @@ OperatorShellMake(const char *operatorName,
 	/*
 	 * insert our "shell" operator tuple
 	 */
-	CatalogTupleInsert(pg_operator_desc, tup);
+	CatalogTupleInsert(pg_operator_desc, tup, NULL);
 
 	/* Add dependencies for the entry */
 	makeOperatorDependencies(tup, true, false);
@@ -333,9 +336,9 @@ OperatorCreate(const char *operatorName,
 	Relation	pg_operator_desc;
 	HeapTuple	tup;
 	bool		isUpdate;
-	bool		nulls[Natts_pg_operator];
-	bool		replaces[Natts_pg_operator];
-	Datum		values[Natts_pg_operator];
+	Datum		values[Natts_pg_operator] = {0};
+	bool		nulls[Natts_pg_operator] = {false};
+	Bitmapset  *updated = NULL;
 	Oid			operatorObjectId;
 	bool		operatorAlreadyDefined;
 	Oid			operResultType;
@@ -343,7 +346,6 @@ OperatorCreate(const char *operatorName,
 				negatorId;
 	bool		selfCommutator = false;
 	NameData	oname;
-	int			i;
 	ObjectAddress address;
 
 	/*
@@ -447,32 +449,25 @@ OperatorCreate(const char *operatorName,
 	else
 		negatorId = InvalidOid;
 
-	/*
-	 * set up values in the operator tuple
-	 */
-
-	for (i = 0; i < Natts_pg_operator; ++i)
-	{
-		values[i] = (Datum) 0;
-		replaces[i] = true;
-		nulls[i] = false;
-	}
+	/* Set up values in the operator tuple */
+	HeapTupleUpdateSetAllColumnsUpdated(pg_operator, updated);
+	HeapTupleSetColumnNotUpdated(pg_operator, oid, updated);
 
 	namestrcpy(&oname, operatorName);
-	values[Anum_pg_operator_oprname - 1] = NameGetDatum(&oname);
-	values[Anum_pg_operator_oprnamespace - 1] = ObjectIdGetDatum(operatorNamespace);
-	values[Anum_pg_operator_oprowner - 1] = ObjectIdGetDatum(GetUserId());
-	values[Anum_pg_operator_oprkind - 1] = CharGetDatum(leftTypeId ? 'b' : 'l');
-	values[Anum_pg_operator_oprcanmerge - 1] = BoolGetDatum(canMerge);
-	values[Anum_pg_operator_oprcanhash - 1] = BoolGetDatum(canHash);
-	values[Anum_pg_operator_oprleft - 1] = ObjectIdGetDatum(leftTypeId);
-	values[Anum_pg_operator_oprright - 1] = ObjectIdGetDatum(rightTypeId);
-	values[Anum_pg_operator_oprresult - 1] = ObjectIdGetDatum(operResultType);
-	values[Anum_pg_operator_oprcom - 1] = ObjectIdGetDatum(commutatorId);
-	values[Anum_pg_operator_oprnegate - 1] = ObjectIdGetDatum(negatorId);
-	values[Anum_pg_operator_oprcode - 1] = ObjectIdGetDatum(procedureId);
-	values[Anum_pg_operator_oprrest - 1] = ObjectIdGetDatum(restrictionId);
-	values[Anum_pg_operator_oprjoin - 1] = ObjectIdGetDatum(joinId);
+	HeapTupleUpdateValue(pg_operator, oprname, NameGetDatum(&oname), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprnamespace, ObjectIdGetDatum(operatorNamespace), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprowner, ObjectIdGetDatum(GetUserId()), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprkind, CharGetDatum(leftTypeId ? 'b' : 'l'), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprcanmerge, BoolGetDatum(canMerge), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprcanhash, BoolGetDatum(canHash), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprleft, ObjectIdGetDatum(leftTypeId), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprright, ObjectIdGetDatum(rightTypeId), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprresult, ObjectIdGetDatum(operResultType), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprcom, ObjectIdGetDatum(commutatorId), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprnegate, ObjectIdGetDatum(negatorId), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprcode, ObjectIdGetDatum(procedureId), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprrest, ObjectIdGetDatum(restrictionId), values, nulls, updated);
+	HeapTupleUpdateValue(pg_operator, oprjoin, ObjectIdGetDatum(joinId), values, nulls, updated);
 
 	pg_operator_desc = table_open(OperatorRelationId, RowExclusiveLock);
 
@@ -489,14 +484,9 @@ OperatorCreate(const char *operatorName,
 			elog(ERROR, "cache lookup failed for operator %u",
 				 operatorObjectId);
 
-		replaces[Anum_pg_operator_oid - 1] = false;
-		tup = heap_modify_tuple(tup,
-								RelationGetDescr(pg_operator_desc),
-								values,
-								nulls,
-								replaces);
+		tup = heap_update_tuple(tup, RelationGetDescr(pg_operator_desc), values, nulls, updated);
 
-		CatalogTupleUpdate(pg_operator_desc, &tup->t_self, tup);
+		CatalogTupleUpdate(pg_operator_desc, &tup->t_self, tup, updated, NULL);
 	}
 	else
 	{
@@ -505,12 +495,12 @@ OperatorCreate(const char *operatorName,
 		operatorObjectId = GetNewOidWithIndex(pg_operator_desc,
 											  OperatorOidIndexId,
 											  Anum_pg_operator_oid);
-		values[Anum_pg_operator_oid - 1] = ObjectIdGetDatum(operatorObjectId);
+		HeapTupleUpdateValue(pg_operator, oid, ObjectIdGetDatum(operatorObjectId), values, nulls, updated);
 
 		tup = heap_form_tuple(RelationGetDescr(pg_operator_desc),
 							  values, nulls);
 
-		CatalogTupleInsert(pg_operator_desc, tup);
+		CatalogTupleInsert(pg_operator_desc, tup, NULL);
 	}
 
 	/* Add dependencies for the entry */
@@ -536,6 +526,7 @@ OperatorCreate(const char *operatorName,
 	/* Post creation hook for new operator */
 	InvokeObjectPostCreateHook(OperatorRelationId, operatorObjectId, 0);
 
+	bms_free(updated);
 	table_close(pg_operator_desc, RowExclusiveLock);
 
 	return address;
@@ -708,6 +699,7 @@ OperatorUpd(Oid baseId, Oid commId, Oid negId, bool isDelete)
 	if (HeapTupleIsValid(tup))
 	{
 		Form_pg_operator t = (Form_pg_operator) GETSTRUCT(tup);
+		Bitmapset  *updated = NULL;
 		bool		update_commutator = false;
 
 		/*
@@ -717,7 +709,7 @@ OperatorUpd(Oid baseId, Oid commId, Oid negId, bool isDelete)
 		 */
 		if (isDelete && OidIsValid(t->oprcom))
 		{
-			t->oprcom = InvalidOid;
+			HeapTupleUpdateField(pg_operator, oprcom, InvalidOid, t, updated);
 			update_commutator = true;
 		}
 		else if (!isDelete && t->oprcom != baseId)
@@ -745,14 +737,14 @@ OperatorUpd(Oid baseId, Oid commId, Oid negId, bool isDelete)
 									NameStr(t->oprname), t->oprcom)));
 			}
 
-			t->oprcom = baseId;
+			HeapTupleUpdateField(pg_operator, oprcom, baseId, t, updated);
 			update_commutator = true;
 		}
 
 		/* If any columns were found to need modification, update tuple. */
 		if (update_commutator)
 		{
-			CatalogTupleUpdate(pg_operator_desc, &tup->t_self, tup);
+			CatalogTupleUpdate(pg_operator_desc, &tup->t_self, tup, updated, NULL);
 
 			/*
 			 * Do CCI to make the updated tuple visible.  We must do this in
@@ -763,6 +755,8 @@ OperatorUpd(Oid baseId, Oid commId, Oid negId, bool isDelete)
 			 */
 			CommandCounterIncrement();
 		}
+
+		bms_free(updated);
 	}
 
 	/*
@@ -777,6 +771,7 @@ OperatorUpd(Oid baseId, Oid commId, Oid negId, bool isDelete)
 	{
 		Form_pg_operator t = (Form_pg_operator) GETSTRUCT(tup);
 		bool		update_negator = false;
+		Bitmapset  *updated = NULL;
 
 		/*
 		 * We can skip doing anything if the negator's oprnegate field is
@@ -785,7 +780,7 @@ OperatorUpd(Oid baseId, Oid commId, Oid negId, bool isDelete)
 		 */
 		if (isDelete && OidIsValid(t->oprnegate))
 		{
-			t->oprnegate = InvalidOid;
+			HeapTupleUpdateField(pg_operator, oprnegate, InvalidOid, t, updated);
 			update_negator = true;
 		}
 		else if (!isDelete && t->oprnegate != baseId)
@@ -813,14 +808,14 @@ OperatorUpd(Oid baseId, Oid commId, Oid negId, bool isDelete)
 									NameStr(t->oprname), t->oprnegate)));
 			}
 
-			t->oprnegate = baseId;
+			HeapTupleUpdateField(pg_operator, oprnegate, baseId, t, updated);
 			update_negator = true;
 		}
 
 		/* If any columns were found to need modification, update tuple. */
 		if (update_negator)
 		{
-			CatalogTupleUpdate(pg_operator_desc, &tup->t_self, tup);
+			CatalogTupleUpdate(pg_operator_desc, &tup->t_self, tup, updated, NULL);
 
 			/*
 			 * In the deletion case, do CCI to make the updated tuple visible.
@@ -831,6 +826,8 @@ OperatorUpd(Oid baseId, Oid commId, Oid negId, bool isDelete)
 			if (isDelete)
 				CommandCounterIncrement();
 		}
+
+		bms_free(updated);
 	}
 
 	/* Close relation and release catalog lock. */
